package ejb31.war.servlet;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptors;
import javax.interceptor.InvocationContext;
import javax.ejb.Stateless;
import javax.annotation.Resource;
import javax.ejb.EJB;

@Stateless
@Interceptors(ProfileInterceptor.class)
public class HelloBean {

    @EJB MessageBean msg;
    String MESSAGE = "Hello";
    String MESSAGE2 = "Permission";

    @Resource
    private javax.ejb.SessionContext ctx;

    public String sayHello() {
        String hello = new String ("Hello from a interceptor-enabled bean!");
        if (msg != null && !msg.getMessage().contains(MESSAGE)){
	    msg.appendMessage(MESSAGE);
	}
	return hello;
    }

    @AroundInvoke
    // mark this method as a bean interceptor
    public Object checkPermission(InvocationContext ic) throws Exception {


        if (msg != null && !msg.getMessage().contains(MESSAGE2)){
	    msg.appendMessage(MESSAGE2);
	}        

        System.out.println("*** INTERNAL checkPermission Interceptor invoked for " +ic.getTarget()+" ***");   

        // you can implement your own security framework using interceptors
        /* check it later, but not for v3 prelude
        if (!ctx.getCallerPrincipal().getName().equals("oc4jadmin")) {
            throw new SecurityException("Caller: '"
                    + ctx.getCallerPrincipal().getName()
                    + "' does not have permissions for method "
                    + ic.getMethod());
        }
	*/
        return ic.proceed();
    }

}
