package ejb31.war.servlet;

import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;
import javax.ejb.EJB;

public class ProfileInterceptor {

    @EJB MessageBean msg;
    String MESSAGE = "Profile";

    @AroundInvoke
    public Object profile(InvocationContext ctx) throws Exception {

        if (msg != null && !msg.getMessage().contains(MESSAGE)){
	    msg.appendMessage(MESSAGE);
	}

        long startTime = 0;
        long endTime = 0;
        try {
            startTime = System.currentTimeMillis();
            System.out.println("*** EXTERNAL Profile Interceptor invoked for " +ctx.getTarget()+" ***");   
            return ctx.proceed();
        } finally {
            endTime = System.currentTimeMillis();
            System.out.println("*** Method " + ctx.getMethod()
                    + " executed in " + (endTime - startTime) + "ms ***");
        }

    }
}

